| CUTLASS CUDA Templates for Linear Algebra Subroutines and Solvers

- Main Page
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
cutlass::layout::ColumnMajorInterleaved< Interleave > Struct Template Reference

`#include <matrix.h>`

## Public Types
using | Index = int32_t
| Index type used for coordinates. More...
using | LongIndex = int64_t
| Long index type used for offsets. More...
using | TensorCoord = MatrixCoord
| Logical coordinate. More...
using | Stride = Coord< kStrideRank, Index >
| Stride vector. More...

## Public Member Functions
CUTLASS_HOST_DEVICE | ColumnMajorInterleaved (Index ldm=0)
| Ctor. More...
CUTLASS_HOST_DEVICE | ColumnMajorInterleaved (Stride stride)
| Ctor. More...
CUTLASS_HOST_DEVICE LongIndex | operator() (MatrixCoord const &coord) const
CUTLASS_HOST_DEVICE MatrixCoord | inverse (LongIndex offset) const
| Inverse of layout function, mapping linear offset to logical coordinate. More...
CUTLASS_HOST_DEVICE Stride | stride () const
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Stride & | stride ()
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Index | stride (int idx) const
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE Index & | stride (int idx)
| Returns the stride of the layout. More...
CUTLASS_HOST_DEVICE LongIndex | capacity (MatrixCoord const &extent) const
| Compute the number of contiguous elements needed to store a tensor with the given size. More...

## Static Public Member Functions
static CUTLASS_HOST_DEVICE ColumnMajorInterleaved | packed (MatrixCoord const &extent)
| Helper returns a layout to a tightly packed tensor. More...

## Static Public Attributes
static int const | kRank = 2
| Logical rank of tensor. More...
static int const | kStrideRank = 1
| Rank of stride vector. More...
static int const | kInterleave = Interleave
| Size of interleaved columns. More...

## Detailed Description

### template<int Interleave>
struct cutlass::layout::ColumnMajorInterleaved< Interleave >

Mapping function for interleaved matrices. Matrix is structured as column-major arrangement of fixed-size rows.

## Member Typedef Documentation

template<int Interleave>

using cutlass::layout::ColumnMajorInterleaved< Interleave >::Index = int32_t

template<int Interleave>

using cutlass::layout::ColumnMajorInterleaved< Interleave >::LongIndex = int64_t

template<int Interleave>

using cutlass::layout::ColumnMajorInterleaved< Interleave >::Stride = Coord<kStrideRank, Index>

template<int Interleave>

using cutlass::layout::ColumnMajorInterleaved< Interleave >::TensorCoord = MatrixCoord

## Constructor & Destructor Documentation

template<int Interleave>

CUTLASS_HOST_DEVICE cutlass::layout::ColumnMajorInterleaved< Interleave >::ColumnMajorInterleaved | ( | Index | ldm = `0` | ) |
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE cutlass::layout::ColumnMajorInterleaved< Interleave >::ColumnMajorInterleaved | ( | Stride | stride | ) |
| inline

## Member Function Documentation

template<int Interleave>

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::ColumnMajorInterleaved< Interleave >::capacity | ( | MatrixCoord const & | extent | ) | const
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE MatrixCoord cutlass::layout::ColumnMajorInterleaved< Interleave >::inverse | ( | LongIndex | offset | ) | const
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE LongIndex cutlass::layout::ColumnMajorInterleaved< Interleave >::operator() | ( | MatrixCoord const & | coord | ) | const
| inline

Returns the offset of a coordinate in linear memory. Assumes coordinate has convention (row, column)

template<int Interleave>

static CUTLASS_HOST_DEVICE ColumnMajorInterleaved cutlass::layout::ColumnMajorInterleaved< Interleave >::packed | ( | MatrixCoord const & | extent | ) |
| inline static

template<int Interleave>

CUTLASS_HOST_DEVICE Stride cutlass::layout::ColumnMajorInterleaved< Interleave >::stride | ( |  | ) | const
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE Stride& cutlass::layout::ColumnMajorInterleaved< Interleave >::stride | ( |  | ) |
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE Index cutlass::layout::ColumnMajorInterleaved< Interleave >::stride | ( | int | idx | ) | const
| inline

template<int Interleave>

CUTLASS_HOST_DEVICE Index& cutlass::layout::ColumnMajorInterleaved< Interleave >::stride | ( | int | idx | ) |
| inline

## Member Data Documentation

template<int Interleave>

int const cutlass::layout::ColumnMajorInterleaved< Interleave >::kInterleave = Interleave
| static

template<int Interleave>

int const cutlass::layout::ColumnMajorInterleaved< Interleave >::kRank = 2
| static

template<int Interleave>

int const cutlass::layout::ColumnMajorInterleaved< Interleave >::kStrideRank = 1
| static

The documentation for this struct was generated from the following file:

- layout/matrix.h